# ParseSource(string)

Method in [Utility](/2.2/api/csharp/yarn.compiler/yarn.compiler.utility.md)

## Summary

Parses a string of Yarn source code, and produces a FileParseResult and (if there were any problems) a collection of diagnostics.

```csharp
public static (FileParseResult, IEnumerable<Diagnostic>) ParseSource(string source)
```

## Parameters

| Name            | Description               |
| --------------- | ------------------------- |
| `string` source | The source code to parse. |

## Returns

A tuple containing a [FileParseResult](/2.2/api/csharp/yarn.compiler/yarn.compiler.fileparseresult.md) that stores the parse tree and tokens, and a collection of [Diagnostic](/2.2/api/csharp/yarn.compiler/yarn.compiler.diagnostic.md) objects that describe problems in the source code.


---

# Agent Instructions: Querying This Documentation

If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://docs.yarnspinner.dev/2.2/api/csharp/yarn.compiler/yarn.compiler.utility/yarn.compiler.utility.parsesource.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
